# AIConfigWindow Struct Reference

Window to configure which AIs will start. More...

Inheritance diagram for AIConfigWindow:

## Public Member Functions
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnInvalidateData (int data)
| Some data on this window has become invalid.
virtual void | OnTick ()
| Called once per (game) tick.
## Data Fields
CompanyID | selected_slot
bool | clicked_button
bool | clicked_increase
int | timeout
int | line_height

## Detailed Description

Window to configure which AIs will start.

Definition at line 505 of file ai_gui.cpp.

## Member Function Documentation

virtual void AIConfigWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 555 of file ai_gui.cpp.

References _settings_newgame, AIC_WIDGET_LIST, GameSettings::difficulty, DrawString(), AIConfig::GetConfig(), AIConfig::GetInfo(), Scrollbar::GetPosition(), Scrollbar::IsVisible(), MAX_COMPANIES, DifficultySettings::max_no_competitors, SetDParamStr(), Window::vscroll, and WD_MATRIX_TOP.

virtual void AIConfigWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 580 of file ai_gui.cpp.

References _network_available, _settings_newgame, GameSettings::ai_config, AIC_WIDGET_CHANGE, AIC_WIDGET_CLOSE, AIC_WIDGET_CONFIGURE, AIC_WIDGET_CONTENT_DOWNLOAD, AIC_WIDGET_DECREASE, AIC_WIDGET_INCREASE, AIC_WIDGET_LIST, AIC_WIDGET_MOVE_DOWN, AIC_WIDGET_MOVE_UP, CONTENT_TYPE_AI, GameSettings::difficulty, Scrollbar::GetPosition(), INVALID_COMPANY, INVALID_STRING_ID, Window::InvalidateData(), max(), MAX_COMPANIES, DifficultySettings::max_no_competitors, min(), Scrollbar::ScrollTowards(), ShowErrorMessage(), ShowNetworkContentListWindow(), Swap(), and Window::vscroll.

virtual void AIConfigWindow::OnInvalidateData | ( | int | data | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented from Window.

Definition at line 645 of file ai_gui.cpp.

References _settings_newgame, AIC_WIDGET_CHANGE, AIC_WIDGET_CONFIGURE, AIC_WIDGET_DECREASE, AIC_WIDGET_INCREASE, AIC_WIDGET_MOVE_DOWN, AIC_WIDGET_MOVE_UP, GameSettings::difficulty, INVALID_COMPANY, MAX_COMPANIES, DifficultySettings::max_no_competitors, and Window::SetWidgetDisabledState().

virtual void AIConfigWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 550 of file ai_gui.cpp.

References Window::DrawWidgets().

virtual void AIConfigWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 531 of file ai_gui.cpp.

References _settings_newgame, AIC_WIDGET_NUMBER, GameSettings::difficulty, DifficultySettings::max_no_competitors, and SetDParam().

virtual void AIConfigWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 540 of file ai_gui.cpp.

References AIC_WIDGET_LIST, FONT_HEIGHT_NORMAL, GB(), MAT_ROW_BITS, MAT_ROW_START, WD_MATRIX_BOTTOM, and WD_MATRIX_TOP.

The documentation for this struct was generated from the following file:

- src/ai/ai_gui.cpp